#!/bin/bash
location='{{ cdd_docker_folders[2] }}'
DATE_LOGFILE=$(date '+%b %d %H:%M:%S')
LOG=$location/docker_cleanup.log
exec 1>> $LOG 2>&1


echo -e "INFO:\t$DATE_LOGFILE: Operation starts..."
exited_namespace=`docker container ls -a --filter status=exited --filter status=created |grep -v "CONTAINER ID" | awk '{ print $1 }'`
if [[ -n $exited_namespace ]]; then
  echo -e "INFO:\t$DATE_LOGFILE: Have found existed containers - cleaning up"
  rm_namespace=`docker container ls -a --filter status=exited --filter status=created |grep -v "CONTAINER ID" | awk '{ print $1 }'`
  docker rm $rm_namespace
else
  echo -e "INFO:\t$DATE_LOGFILE: No stopped namespaces found, nothing to do."
fi

dangling_volumes="$(docker volume ls -qf dangling=true)"
if [[ -n $dangling_volumes ]]; then
  echo -e "INFO:\t$DATE_LOGFILE: Have found unused volumes - cleaning up"
  rm_volume=`docker volume ls -qf dangling=true`
  docker volume rm ${rm_volume}
else
  echo -e "INFO:\t$DATE_LOGFILE: No dangling voluems found, nothing to do."
fi

dangling_images=`docker images --filter "dangling=true" -q --no-trunc | tr -d '\n'`
if [[ -n $dangling_images ]]; then
  echo -e "INFO:\t$DATE_LOGFILE: Have found unused images - cleaning up"
  rm_images=`docker images --filter "dangling=true" -q --no-trunc`
  docker rmi $rm_images
else
  echo -e "INFO:\t$DATE_LOGFILE: No dangling images found, nothing to do."
fi

echo -e "INFO:\t$DATE_LOGFILE: Operation ends here."